Subject: Re: bug#72556: 29.1.90; vc-diff does not undo hunk in end of source file

From: Eli Zaretskii <[email-masked]>
Date: Sat, 14 Sep 2024 10:35:15 +0300

Ping! Would someone want to work on a patch, or should I close this
bug as wontfix?

> Cc: [email-masked]
> Date: Sat, 31 Aug 2024 11:09:36 +0300
> From: Eli Zaretskii <[email-masked]>
> 
> > From: Juri Linkov <[email-masked]>
> > Cc: Tomas Nordin <[email-masked]>,  Dmitry Gutov <[email-masked]>,
> >   [email-masked]
> > Date: Mon, 19 Aug 2024 19:49:05 +0300
> > 
> > >> To reproduce:
> > >>
> > >> $ mkdir apply
> > >> $ cd apply
> > >> $ echo "first line of code" > example.file
> > >> $ git init
> > >> $ git add .
> > >> $ git commit -m 'init'
> > >> $ echo "last line of code" >> example.file
> > >> $ emacs -Q example.file
> > >>
> > >> C-x v =
> > >> n
> > >> C-c C-a
> > >>
> > >> The hunk is applied in the source buffer.
> > >
> > > Juri and Dmitry, any comments or suggestions?
> > 
> > I don't know why it fails at the end, so I tried to debug 'diff-apply-hunk',
> > and found that the problem is in these lines of 'diff-find-source-location':
> > 
> >     ;; FIXME: Check for case where both OLD and NEW are found.
> >     (pos (or (diff-find-text (car old))
> > 
> > When the hunk is at the beginning/end of the diff buffer,
> > then it misses the top/bottom part of the context,
> > so 'diff-find-text' wrongly matches it because it fails
> > to see any changes in it due to insufficient context,
> > and returns switched=nil.
> > 
> > A possible solution would be to add a condition to detect the case
> > when the hunk is at the beginning/end of the diff buffer.
> 
> Thanks.  Would anyone like to submit a patch along these lines?
> 
> 
> 
>